%{!?luaver: %global luaver %(lua -e "print(string.sub(_VERSION, 5))" || echo 0)}
%global lualibdir %{_libdir}/lua/%{luaver}
%global luapkgdir %{_datadir}/lua/%{luaver}

%global luacompatver 5.1
%global luacompatlibdir %{_libdir}/lua/%{luacompatver}
%global luacompatpkgdir %{_datadir}/lua/%{luacompatver}

%global luapkgname luaossl

Name:           lua-%{luapkgname}
Version:        20200709
Release:    2%{?dist}
Summary:        Most comprehensive OpenSSL module in the Lua universe

License:        MIT
URL:            https://github.com/wahern/%{luapkgname}
Source0:        https://github.com/wahern/%{luapkgname}/archive/rel-%{version}/%{name}-%{version}.tar.gz

Patch1:         openssl-3-compat.patch

BuildRequires:  gcc
BuildRequires:  make
BuildRequires:  openssl-devel
BuildRequires:  lua
BuildRequires:  lua-devel
BuildRequires:  compat-lua-devel

Requires:       lua(abi) = %{luaver}

%description
luaossl is a comprehensive binding to OpenSSL for Lua 5.1, 5.2, and later.

%package -n lua%{luacompatver}-%{luapkgname}
Summary:        Most comprehensive OpenSSL module in the Lua universe
Requires:       lua(abi) = %{luacompatver}

%description -n lua%{luacompatver}-%{luapkgname}
luaossl is a comprehensive binding to OpenSSL for Lua 5.1, 5.2, and later.

%package doc
Summary:        Documentation for OpenSSL Lua module
BuildArch:      noarch
Requires:       %{name} = %{version}
Requires:       lua%{luacompatver}-%{luapkgname} = %{version}

%description doc
Documentation for the Stackable Continuation Queues library
for the Lua Programming Language

%prep
%setup -q -n %{luapkgname}-rel-%{version}

%patch1 -p1

%build
export CFLAGS="%{?optflags} -fPIC"
export LDFLAGS="%{?build_ldflags}"
make LUA_APIS="%{luaver}" %{?_smp_mflags} prefix=%{_prefix} libdir=%{_libdir}

make LUA_APIS="%{luacompatver}" %{?_smp_mflags} prefix=%{_prefix} libdir=%{_libdir} CFLAGS="$CFLAGS -I%{_includedir}/lua-%{luacompatver}"

%install
make DESTDIR=%{buildroot} prefix=%{_prefix} libdir=%{_libdir} install%{luaver}
install -d -m 0755 %{buildroot}%{_pkgdocdir}
install -p -m 0644 doc/luaossl.pdf %{buildroot}%{_pkgdocdir}/luaossl.pdf

make DESTDIR=%{buildroot} prefix=%{_prefix} libdir=%{_libdir} install%{luacompatver}

%files
%{luapkgdir}/openssl
%{luapkgdir}/openssl.lua
%{lualibdir}/_openssl.so
%license LICENSE

%files -n lua%{luacompatver}-%{luapkgname}
%{luacompatpkgdir}/openssl
%{luacompatpkgdir}/openssl.lua
%{luacompatlibdir}/_openssl.so
%license LICENSE

%files doc
%{_pkgdocdir}

%changelog
* Tue May 07 2024 Fanjun Kong <fanjunkong@tencent.com> - 20200709-2
- epol debrand

* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 20200709-1
- initial build
